(*
   File   : /home/cvs/cvsroot/projects/visualstate/scope/Normalise.sig,v
   Comment: Normalise Absyn model.
   Release: scope-0-10

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTES:

   Normalisation currently includes: 

   1. removal of single children orstates (empty orstates are illegal at all)
   
   Normalise.sig,v 1.6 2002/10/30 21:36:45 wasowski Exp
*)

signature Normalise = sig

	val normalise : Absyn.model -> Absyn.model
	
	val degroup   : Absyn.evgroup Absyn.env -> Absyn.tran  -> Absyn.tran list
	val degroup_all :
			Absyn.evgroup Absyn.env -> Absyn.tran list -> Absyn.tran list

	val pull_defs : Absyn.denv * Absyn.hierarchy -> Absyn.denv * Absyn.hierarchy
	val rmRedundantTgts : Absyn.hierarchy -> Absyn.tran -> Absyn.tran

(*
	[pull_defs h] restructures hierarchy pulling the initial state
	(initial child) of each or-state to be the first on the children
	list. This slightly violates our semantics (only because this
	semantics is fully deterministic and assumes a single ordering). This
	is perfectly legal in widely accepted semantic definitions for
	statecharts (like UML, and probably Harel). This is used by CodGenC1.
	Reordering should be done before we start to generate the array for
	hierarchy (otherwise this disturbs the canonical preorder addressing
	of states).
*)
end
