(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/UList.sig,v
   Comment: Modelling notupdatable memory arrays of unique elements with lists
   Release: scope-0-10

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  UList.sig,v 1.7 2002/10/24 20:17:10 wasowski Exp
*)
  exception NotFound

  type ''a ulist

  val initialize : (''a -> int) -> ''a ulist

  val alloc : ''a * ''a ulist -> int * ''a ulist
  val find  : ''a * ''a ulist -> int			(* NotFound *)

  val toList   : ''a ulist -> ''a list

  val length : ''a ulist -> int

  val null : ''a ulist -> bool
  

(*
  [''a ulist ] type of addressable lists of unique elements used for
  modelling arrays in code generation. Note that values of ''a ulist are not
  of equality type (unfortunately).

  [empty] empty unique list

  [alloc (u,ul)] if u is in ul then returns its index and ul without change.
  Otherwise adds u to ul and returns its index.

  [fromList xs] builds unique table from list. Returns unique list. Indices
  of elements are not returned.

  [toList xs] translates unique list into ordinary ML list.

  [length xs] returns the size of the whole array (not the number of elements of
  ulist!)

  [find (e,xs)] finds the entry e and returns its *address* -- not the
  position at the list (so if every element has more than one cell then this
  is taken into account).

  [null xs] is true iff the list xs contains no elements
*)


