(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/codgen-sig.sml,v
   Comment: Signature for code generators of scope
   Release: scope-0-10

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   codgen-sig.sml,v 1.7 2002/10/24 20:17:10 wasowski Exp
*)


signature CODGEN = sig

    eqtype options

    val compile : options -> string -> Absyn.model -> unit 

    (* 
       [eqtype options] is the type of compiler options. Can be different for
       various code generators. Equality is needed for testing options
       presence (well not necesarily, but we do it at the moment).
       
       [compile] generate model in *current* directory
    
       [compile1] generate model as above, but also return some
       extra data which may be used in test procedures.

       [stub_actions] generate empty action functions for external functions.
       Should be used for evaluation of models available partly only.
    *)
end 
